<?php
	/**************************************************************************\
	* -------------------------------------------------------------------------*
	* This library is free software; you can redistribute it and/or modify it  *
	* under the terms of the GNU Lesser General Public License as published by *
	* the Free Software Foundation; either version 2.1 of the License,         *
	* or any later version.                                                    *
	* This library is distributed in the hope that it will be useful, but      *
	* WITHOUT ANY WARRANTY; without even the implied warranty of               *
	* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                     *
	* See the GNU Lesser General Public License for more details.              *
	* You should have received a copy of the GNU Lesser General Public License *
	* along with this library; if not, write to the Free Software Foundation,  *
	* Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA            *
	\**************************************************************************/

	/* $Id: class.uifilemanager.inc.php 17511 2004-12-12 06:35:24Z dawnlinux $ */

	class uifilemanager
	{
		var $public_functions = array(
			'index'	=> True,
			'help'	=> True,
			'view'  => True,
			'export'=> True,
			'touch' => True,
			'history' => True,
			'edit' => True,
			'fileModels'=>True,
			'getReturnExecuteForm' => True,
			'uploadModel'=>True
		);

		//keep
		var $bo;
		var $vfs_functions;
		var $t; //template object
		var $dispath;
		var $cwd;
		var $lesspath;
		var $readable_groups;
		var $files_array;
		var $numoffiles;
		var $dispsep;

		var $target;

		var $prefs;//array

		var $groups_applications;

		//originally post_vars
		//		var $goto;
		var $current_config;
		var $goto_x;
		var $todir;
		var $changedir; // for switching dir.
		var $cdtodir; // for switching dir.
//		var $createdir;
		var $newfile_or_dir;
		var $newdir_x;
		var $newfile_x;
		var $createfile_var;
		var $move_to_x;
//		var $copy_to;
		var $copy_to_x;
		var $edit_x;
		var $edit_file;
		var $edit_preview_x;
		var $edit_save_x;
		var $edit_save_done_x;
		var $edit_cancel_x;
		var $upload_x;

		// this ones must be checked thorougly;
		var $fileman = Array();
		//var $fileman;
		var $path;
		var $file; // FIXME WHERE IS THIS FILLED?
		var $sortby;
		var $messages = array();
		var $show_upload_boxes;

		var $now;

		function uifilemanager()
		{
			//			error_reporting(8);
			$GLOBALS['phpgw']->browser = CreateObject('phpgwapi.browser');

			$this->now = date('Y-m-d');

			$this->bo = CreateObject('filemanager.bofilemanager');

			$this->vfs_functions = CreateObject('filemanager.vfs_functions');

			$this->t = $GLOBALS['phpgw']->template;
			$c = CreateObject('phpgwapi.config','filemanager');
			$c->read_repository();
			$this->current_config = $c->config_data;


			// here local vars are created from the HTTP vars
			@reset($GLOBALS['HTTP_POST_VARS']);
			while(list($name,) = @each($GLOBALS['HTTP_POST_VARS']))
			{
				$this->$name = $GLOBALS['HTTP_POST_VARS'][$name];
			}

			@reset($GLOBALS['HTTP_GET_VARS']);
			while(list($name,) = @each($GLOBALS['HTTP_GET_VARS']))
			{
				$$name = $GLOBALS['HTTP_GET_VARS'][$name];
				$this->$name = $GLOBALS['HTTP_GET_VARS'][$name];

			}

			$to_decode = array
			(
				'op'	=> array('op' => ''),
				'path'	=> array('path' => ''),
				'filename' => array('filename' => ''),
				'file'	=> array('file' => ''),
				'sortby'	=> array('sortby' => ''),
				'messages'	=> array('messages'	=> ''),
				'show_upload_boxes'	=> array('show_upload_boxes' => '')
			);

			reset($to_decode);
			while(list($var, $conditions) = each($to_decode))
			{
				while(list($condvar, $condvalue) = each($conditions))
				{
					if(isset($$condvar) && ($condvar == $var || $$condvar == $condvalue))
					{
						if(is_array($$var))
						{
							$temp = array();
							while(list($varkey, $varvalue) = each($$var))
							{
								if(is_int($varkey))
								{
									$temp[$varkey] = stripslashes(base64_decode(urldecode(($varvalue))));
								}
								else
								{
									$temp[stripslashes(base64_decode(urldecode(($varkey))))] = $varvalue;
								}
							}
							$this->$var = $temp;
						}
						elseif(isset($$var))
						{
							$this->$var = stripslashes(base64_decode(urldecode($$var)));
						}
					}
				}
			}

			// get appl. and user prefs
			$pref = CreateObject('phpgwapi.preferences', $this->bo->userinfo['username']);
			$pref->read_repository();
			//$GLOBALS['phpgw']->hooks->single('add_def_pref', $GLOBALS['appname']);
			$pref->save_repository(True);
			$pref_array = $pref->read_repository();
			$this->prefs = $pref_array[$this->bo->appname]; //FIXME check appname var in _debug_array

			//always show name

			$this->prefs[name] =1;


			if($this->prefs['viewinnewwin'])
			{
				$this->target = '_blank';
			}


			/*
				Check for essential directories
				admin must be able to disable these tests
			*/
			
			// check if basedir exist 
			$test=$this->bo->vfs->get_real_info(array('string' => $this->bo->basedir, 'relatives' => array(RELATIVE_NONE), 'relative' => False));
			if($test[mime_type]!='Directory')
			{
				die('Base directory does not exist, Ask adminstrator to check the global configuration.');
			}

			$test=$this->bo->vfs->get_real_info(array('string' => $this->bo->basedir.$this->bo->fakebase, 'relatives' => array(RELATIVE_NONE), 'relative' => False));
			if($test[mime_type]!='Directory')
			{

				$this->bo->vfs->override_acl = 1;

				$this->bo->vfs->mkdir(array(
					'string' => $this->bo->fakebase,
					'relatives' => array(RELATIVE_NONE)
				));
				
				$this->bo->vfs->override_acl = 0;

				//test one more time
				$test=$this->bo->vfs->get_real_info(array('string' => $this->bo->basedir.$this->bo->fakebase, 'relatives' => array(RELATIVE_NONE), 'relative' => False));

				if($test[mime_type]!='Directory')
				{
					die('Fake Base directory does not exist and could not be created, please ask the administrator to check the global configuration.');
				}
				else
				{
					$this->messages[]= lang('Fake Base Dir did not exist, eGroupWare created a new one.');
				}
			}

			$test=$this->bo->vfs->get_real_info(array('string' => $this->bo->basedir.$this->bo->homedir, 'relatives' => array(RELATIVE_NONE), 'relative' => False));
			if($test[mime_type]!='Directory')
			{
				$this->bo->vfs->override_acl = 1;

				$this->bo->vfs->mkdir(array(
					'string' => $this->bo->homedir,
					'relatives' => array(RELATIVE_NONE)
				));
				$this->bo->vfs->set_quota(array(
					'string' => $this->bo->homedir,
					'relatives' => array(RELATIVE_NONE),
					'new_quota' => $this->current_config['filemanager_quota_size'] 
				));
	
				$this->bo->vfs->override_acl = 0;

				//test one more time
				$test=$this->bo->vfs->get_real_info(array('string' => $this->bo->basedir.$this->bo->homedir, 'relatives' => array(RELATIVE_NONE), 'relative' => False));

				if($test[mime_type]!='Directory')
				{
					die('Your Home Dir does not exist and could not be created, please ask the adminstrator to check the global configuration.');
				}
				else
				{
					$this->messages[]= lang('Your Home Dir did not exist, eGroupWare created a new one.');
					// FIXME we just created a fresh home dir so we know there nothing in it so we have to remove all existing content
				}


			}
			
		}
		function fileModels()
		{
			$GLOBALS['phpgw_info']['flags'] = array
				(
					'currentapp'    => 'filemanager',
					'noheader'      => False,
					'nonavbar' => False,
					'nofooter'      => False,
					'noappheader'   => False,
					'enable_browser_class'  => True
				);

			$GLOBALS['phpgw']->common->phpgw_header();
			$this->t->set_file(array('models' => 'fileModels.tpl'));
			$this->t->set_block('models','header','header');
			$this->t->set_block('models','body','body');
			$this->t->set_block('models','footer','footer');
			$this->t->set_var('url_1', './index.php?menuaction=filemanager.uifilemanager.uploadModel&model=article');
			$this->t->set_var('model_1','article');
			$this->t->set_var('lang_1',lang('article'));

			$this->t->set_var('url_2','./index.php?menuaction=filemanager.uifilemanager.uploadModel&model=calendar');
			$this->t->set_var('model_2','calendar');
			$this->t->set_var('lang_2',lang('calendar'));

			$this->t->set_var('url_3','./index.php?menuaction=filemanager.uifilemanager.uploadModel&model=todo');
			$this->t->set_var('model_3','todo');
			$this->t->set_var('lang_3',lang('todo'));

			$this->t->set_var('url_4','./index.php?menuaction=filemanager.uifilemanager.uploadModel&model=slide');
			$this->t->set_var('model_4','slide');
			$this->t->set_var('lang_4',lang('slide'));

			$this->t->set_var('url_5','./index.php?menuaction=filemanager.uifilemanager.uploadModel&model=cards');
			$this->t->set_var('model_5','cards');
			$this->t->set_var('lang_5',lang('cards'));

			$this->t->set_var('url_6','./index.php?menuaction=filemanager.uifilemanager.uploadModel&model=resume');
			$this->t->set_var('model_6','resume');
			$this->t->set_var('lang_6',lang('resume'));


			$this->t->pparse('out','models');


		}
		function uploadModel(){
			$GLOBALS['phpgw_info']['flags'] = array
				(
					'currentapp'    => 'filemanager',
					'noheader'      => False,
					'nonavbar' => False,
					'nofooter'      => False,
					'noappheader'   => False,
					'enable_browser_class'  => True
				);

			$GLOBALS['phpgw']->common->phpgw_header();

			$filename = lang('new')."_".lang($this->model).rand(0,1000).".html";
			$this->bo->vfs->cp(array(
				'from'=> PHPGW_SERVER_ROOT . '/filemanager/templates/default/'.$this->model.'.html',
				'to'=> $filename,
				'relatives'     => array(RELATIVE_NONE|VFS_REAL, RELATIVE_ALL)
			));

			$this->bo->vfs->set_attributes(array(
				'string'=> $filename,
				'relatives'     => array(RELATIVE_ALL),
				'attributes'=> array(
					'mime_type' => "text/html",
					'comment' => ""
				)
			));
			$this->filename = $filename;
			$this->edit();

		}
		function index()
		{
			$GLOBALS['phpgw_info']['flags'] = array
			(
				'currentapp'	=> 'filemanager',
				'noheader'	=> False,
				'nonavbar' => False,
				'nofooter'	=> False,
				'noappheader'	=> False,
				'enable_browser_class'	=> True
			);

			$GLOBALS['phpgw']->common->phpgw_header();

			echo "<script src='".$GLOBALS['phpgw_info']['flags']['currentapp']."/js/global.js'></script>";
			echo "<script src='".$GLOBALS['phpgw_info']['flags']['currentapp']."/js/main.js'></script>";
			echo "<script src='".$GLOBALS['phpgw_info']['flags']['currentapp']."/js/common_functions.js'></script>";
			echo "<script src='".$GLOBALS['phpgw_info']['flags']['currentapp']."/js/connector.js'></script>";
			echo "<script src='".$GLOBALS['phpgw_info']['flags']['currentapp']."/js/draw_api.js'></script>";
			include('load_lang.php');

			# Page to process users
			# Code is fairly hackish at the beginning, but it gets better
			# Highly suggest turning wrapping off due to long SQL queries

			###
			# Some hacks to set and display directory paths correctly
			###
			// new method for switching to a new dir.
			if($this->changedir=='true' && $this->cdtodir || $this->goto_x)
			{
				$this->path = $this->cdtodir;
			}

			if(!$this->path)
			{
				$this->path = $this->bo->vfs->pwd();

				if(!$this->path || $this->bo->vfs->pwd(array('full' => False)) == '')
				{
					$this->path = $this->bo->homedir; 
				}
			}

			$this->bo->vfs->cd(array('string' => False, 'relatives' => array(RELATIVE_NONE), 'relative' => False));
			$this->bo->vfs->cd(array('string' => $this->path, 'relatives' => array(RELATIVE_NONE), 'relative' => False));

			$pwd = $this->bo->vfs->pwd();

			if(!$this->cwd = substr($this->path, strlen($this->bo->homedir) + 1))  
			{
				$this->cwd = '/';
			}
			else
			{
				$this->cwd = substr($pwd, strrpos($pwd, '/') + 1);
			}

			$this->disppath = $this->path;

			/* This just prevents // in some cases */
			if($this->path == '/')
			{
				$this->dispsep = '';
			}
			else
			{
				$this->dispsep = '/';
			}

			if(!($this->lesspath = substr($this->path, 0, strrpos($this->path, '/'))))
			{
				$this->lesspath = '/';
			}

			# Get their readable groups to be used throughout the script
			$acl = array();
			$groups = array();
			$acl = $GLOBALS['phpgw']->acl->get_ids_for_location($GLOBALS['phpgw_info']['user']['account_id'],1,'filemanager');
	 		if (is_array($acl))
				foreach($acl as $key => $value){
					$info = array();
					$info = $GLOBALS['phpgw']->accounts->get_account_data($value);
					$groups[$key]['account_id'] = $value;
					$groups[$key]['account_lid'] = $info[$value]['lid'];
					$groups[$key]['account_name'] = $info[$value]['firstname'];
					$groups[$key]['account_lastname'] = $info[$value]['lastname'];
					$groups[$key]['account_fullname'] = $info[$value]['fullname'];
				}
			$this->readable_groups = array();
			while(list($num, $account) = each($groups))
			{
				if($this->bo->vfs->acl_check(array('owner_id' => $account['account_id'],'operation' => PHPGW_ACL_READ)))
				{
					$this->readable_groups[$account['account_lid']] = Array('account_id' => $account['account_id'], 'account_name' => $account['account_lid']);
				}
			}

			$this->groups_applications = array();

			foreach ($this->readable_groups as $value)
			{
				$applications = CreateObject('phpgwapi.applications', $value['account_id']);
				$this->groups_applications[$value['account_name']] = $applications->read_account_specific();
			}

			# We determine if they're in their home directory or a group's directory,
			# and set the VFS working_id appropriately
			if((preg_match('+^'.$this->bo->fakebase.'\/(.*)(\/|$)+U', $this->path, $matches)) && $matches[1] != $this->bo->userinfo['account_lid']) //FIXME matches not defined

			{
				$this->bo->vfs->working_id = $GLOBALS['phpgw']->accounts->name2id($matches[1]);//FIXME matches not defined

			}
			else
			{
				$this->bo->vfs->working_id = $this->bo->userinfo['username'];
			}

			# Check available permissions for $this->path, so we can disable unusable operations in user interface
			$path = explode('/',$this->path);
			$owner_id = $this->bo->vfs->ownerOf($this->bo->fakebase,$path[2]);
			$user_id = $GLOBALS['phpgw_info']['user']['account_id'];
			if ($owner_id == $user_id)
			{
				$this->can_read = True;
				$this->can_add = True;
				$this->can_edit = True;
				$this->can_delete = True;
				$this->can_private = True;
			}else
			{
				$acl = CreateObject ('phpgwapi.acl', $owner_id);
				$acl->account_id = $owner_id;
				$acl->read_repository();
				$rights = $acl->get_rights($user_id);
				$this->can_read = $rights & PHPGW_ACL_READ;
				$this->can_add = $rights & PHPGW_ACL_ADD;
				$this->can_edit = $rights & PHPGW_ACL_EDIT;
				$this->can_delete = $rights & PHPGW_ACL_DELETE;
				$this->can_private = $rights & PHPGW_ACL_PRIVATE;
			}
	
			# if is different path than home and no permission allowed
			if($this->path != $this->bo->homedir && $this->path != $this->bo->fakebase && $this->path != '/' && !$this->can_read)
			{
				echo lang('You do not have access to %1', $this->path);
				$this->html_link('/index.php','menuaction=filemanager.uifilemanager.index','path='.$this->homedir, lang('Go to your home directory'));

				$GLOBALS['phpgw']->common->phpgw_footer();
				$GLOBALS['phpgw']->common->phpgw_exit();
			}

			$this->bo->userinfo['working_id'] = $this->bo->vfs->working_id;
			$this->bo->userinfo['working_lid'] = $GLOBALS['phpgw']->accounts->id2name($this->bo->userinfo['working_id']);

			# Verify path is real
			if($this->path != $this->bo->homedir && $this->path != '/' && $this->path != $this->bo->fakebase)
			{
				if(!$this->bo->vfs->file_exists(array(
					'string' => $this->path,
					'relatives' => array(RELATIVE_NONE)
				)))
				{
					$this->messages[] = lang('Error:').lang('Directory %1 does not exist', $this->path);
					$this->html_link('/index.php','menuaction=filemanager.uifilemanager.index','path='.$this->bo->homedir, lang('Go to your home directory'));

					$GLOBALS['phpgw']->common->phpgw_footer();
					$GLOBALS['phpgw']->common->phpgw_exit();
				}
			}


			/* Update the vfs */
			if ($this->update_x == 'True') 
			{
				$this->bo->vfs->update_real(array(
					'string' => $this->path,
					'relatives' => array(RELATIVE_ALL)
				));
			}

			# Default is to sort by name
			if(!$this->sortby)
			{
				$this->sortby = 'name';
			}

			# main action switch
			// FIXME this will become a switch
			if($this->newfile_x && $this->newfile_or_dir) // create new textfile
			{
				$this->createfile();
			}
			elseif($this->newfile_or_dir && $this->newdir_x)
			{
				$this->createdir();
			}
			elseif($this->upload_x || $this->show_upload_boxes)
			{
				$this->showUploadboxes();
			}
			elseif($this->copy_to_x)
			{
				$this->copyTo();
			}
			elseif($this->move_to_x)
			{
				$this->moveTo();
			}
			elseif($this->edit_cancel_x)
			{
				$this->readFilesInfo();
				$this->fileListing();
			}
			elseif($this->edit_x || $this->edit_preview_x || $this->edit_save_x || $this->edit_save_done_x)
			{
				$this->edit();
			}
			else
			{
				$this->readFilesInfo();
				$this->fileListing();
			}
		}
		function fileListing()
		{
			$this->t->set_file(array('filemanager_list_t' => 'filelisting.tpl'));
			$this->t->set_block('filemanager_list_t','filemanager_header','filemanager_header');
			$this->t->set_block('filemanager_list_t','column','column');
			$this->t->set_block('filemanager_list_t','row','row');
			$this->t->set_block('filemanager_list_t','filemanager_footer','filemanager_footer');

			$vars['form_action']=$this->encode_href('/index.php', 'menuaction=filemanager.uifilemanager.index','path='.$this->path);
			if($this->numoffiles || $this->cwd)
			{
				while(list($num, $name) = each($this->prefs))
				{
					if($name)
					{
						$columns++;
					}
				}
				$columns++;
				$usedSpace = $this->bo->vfs->get_size(array(
					'string'        => $this->path,
					'relatives'     => array(RELATIVE_NONE)
				));
				$quota = $this->bo->vfs->get_quota(array(
					'string'        => $this->path
				));

				$vars[usedSpace]='<input type="hidden" id="usedSpace" value="'.$usedSpace.'">';
				$vars[quotaSize]='<input type="hidden" id="quotaSize" value="'.($quota*1024*1024).'">';
				$vars[path]='<input type="hidden" id="currentPath" value="'.$this->path.'">';
				$vars[css]='<script>initDrawApi();</script>
					<link rel="stylesheet" type="text/css" href="filemanager/templates/default/main.css">';
				$vars[toolbar0]=$this->toolbar('location');
				$vars[toolbar1]=$this->toolbar('list_nav');

				if(count($this->messages)>0) 
				{
					foreach($this->messages as $msg)
					{
						$messages.='<p>'.$msg.'</p>';
					}
				}

				$vars[messages]=$messages;

				$this->t->set_var($vars);
				$this->t->pparse('out','filemanager_header');

				###
				# Start File Table Column Headers
				# Reads values from $file_attributes array and preferences
				###
				$this->t->set_var('actions',lang('select'));
				$this->t->set_var('mini_bar','&nbsp;');


				reset($this->bo->file_attributes);

				if($this->numoffiles>0)
				{
					while(list($internal, $displayed) = each($this->bo->file_attributes))
					{
						if($this->prefs[$internal])
						{
							if ($internal != 'owner')
								$col_data='<span><a href="'.$this->encode_href('/index.php','menuaction=filemanager.uifilemanager.index','path='.$this->path.'&sortby='.$internal).'">'.$displayed.'</a></span>';
							else
								$col_data='<span>'.$displayed.'</span>';
							$this->t->set_var('col_data',$col_data);
							$this->t->parse('columns','column',True);
						}
					}

					$this->t->set_var('row_tr_color','#dedede');
					
					$this->t->parse('rows','row');
					
					$this->t->pparse('out','row');
				}
				else
				{
					$lang_nofiles=lang('No files in this directory.');
				}
				$vars[lang_no_files]=$lang_nofiles;


				if($this->prefs['dotdot'] && $this->prefs['name'] && $this->path != '/')
				{
					$this->t->set_var('actions','');

					$link=$this->encode_href('/index.php','menuaction=filemanager.uifilemanager.index','path='.$this->lesspath);

					$col_data='<a href="'.$link.'"><img src="'.$GLOBALS['phpgw']->common->image('filemanager','mime16up').' "alt="'.lang('Folder Up').'" /></a>';
					$col_data.='&nbsp;<a href="'.$link.'">..</a>';

					$this->t->set_var('col_data',$col_data);
					$this->t->parse('columns','column');

					if($this->prefs['mime_type'])
					{
						$col_data=lang('Directory');
						$this->t->set_var('col_data',$col_data);
						$this->t->parse('columns','column',True);
					}

					$this->t->set_var('row_tr_color',$tr_color);
					$this->t->parse('rows','row');
					$this->t->pparse('out','row');
				}

				# List all of the files, with their attributes
				@reset($this->files_array);
				for($i = 0; $i != $this->numoffiles; $i++)
				{
					$files = $this->files_array[$i];
					

					if(!$this->prefs['dotfiles'] && ereg("^\.", $files['name']))
					{
						continue;
					}

					# Checkboxes
					if($this->path != $this->bo->fakebase && $this->path != '/')
					{
						$cbox='<input type="checkbox" name="fileman" value="'.$files['name'].'">';
						$this->t->set_var('actions',$cbox);
					}
					else
					{
						$this->t->set_var('actions','');
					}
					$minibar_data="";
					if($this->can_private)
					{
						if ($files['type'] == "1")
						{
							$image = $GLOBALS['phpgw']->common->image('filemanager','button_lock');
						}
						else
						{
							$image = $GLOBALS['phpgw']->common->image('filemanager','button_unlock');
						}
						$link=$this->encode_href('/index.php','menuaction=filemanager.vfs_functions.setRestricted','file='.$files['name'].'&path='.$this->path);
						$minibar_data = '<img id="restrict_'.$files['name'].'" onClick="cExecute(\''.$link.'\',setRestricted)" alt="'.lang("mark as restricted").'" title="'.lang("mark as restricted").'" src="'.$image.'">';
					}


					if ($files['mime_type'] == "text/html")
					{
						$link=$this->encode_href('/index.php','menuaction=filemanager.uifilemanager.export','file='.$files['name'].'&path='.$this->path);
						$image=$GLOBALS['phpgw']->common->image('filemanager','button_export');
						$minibar_data.='<a href="'.$link.'"><img alt="'.lang("export").'" title="'.lang("export").'" src="'.$image.'"></a>';
					}
					else
						$minibar_data.= "<a>&nbsp;</a>";
					$this->t->set_var('mini_bar',$minibar_data);


					# File name and icon
					if($files['mime_type'] == 'Directory')
					{
						$link=$this->encode_href('/index.php','menuaction=filemanager.uifilemanager.index','path='.$this->path.$this->dispsep.$files['name']);

						$icon=$this->mime_icon($files['mime_type']);

						$col_data='<a href="'.$link.'">'.$icon.'</a>&nbsp;';
						$col_data.='<a href="'.$link.'">'.$files['name'].'</a>&nbsp;';
					}
					else
					{

						if($this->prefs['viewonserver'] && isset($this->bo->filesdir) && !$files['link_directory'])
						{
							#FIXME
							$clickview = $this->filesdir.$pwd.'/'.$files['name'];

						}
						else
						{
							$icon=$this->mime_icon($files['mime_type']);
							$link=$this->encode_href('/index.php','menuaction=filemanager.uifilemanager.view','file='.$files['name'].'&path='.$this->path);
							//$link=$this->encode_href('inc/download.php','file='.base64_encode($files['name']).'&path='.base64_encode($this->path));

							$col_data='<a href="'.$link.'" target="'.$this->target.'">'.$icon.'</a>&nbsp;'.
							'<a id="name_'.$files['name'].'" href="'.$link.'" target="'.$this->target.'">'.$files['name'].'</a>';
						}
					}


					$this->t->set_var('col_data',$col_data);
					$this->t->parse('columns','column');

					# MIME type
					if($this->prefs['mime_type'])
					{
						$col_data=$files['mime_type'];
						$this->t->set_var('col_data',$col_data);
						$this->t->parse('columns','column',True);
					}

					# File size
					if($this->prefs['size'])
					{
						$tmp_arr=array(
							'string'	=> $files['directory'] . '/' . $files['name'],
							'relatives'	=> array(RELATIVE_NONE)
						);
						if($files['mime_type'] != 'Directory') $tmp_arr['checksubdirs'] = false;

						$size = $this->bo->vfs->get_size($tmp_arr);

						$col_data=$this->bo->borkb($size);

						$this->t->set_var('col_data',$col_data);
						$this->t->parse('columns','column',True);
					}

					# Date created
					if($this->prefs['created'])
					{
						$timestamp = $this->vfs_functions->dateString2timeStamp($files['created']);
						if (time() - $timestamp > 86400) // Older than yesterday
							$col_data=date("Y-m-d",$timestamp);
						else
							$col_data=date("H:i",$timestamp);
						$this->t->set_var('col_data',$col_data);
						$this->t->parse('columns','column',True);
					}

					# Date modified
					if($this->prefs['modified'])
					{
						if ($files['modified'] != ''){
							$timestamp = $this->vfs_functions->dateString2timeStamp($files['modified']);
							if (time() - $timestamp > 86400) // Older than yesterday
								$col_data=date("Y-m-d",$timestamp);
							else
								$col_data=date("H:i",$timestamp);
						}
						else
							$col_data='';
						$this->t->set_var('col_data',$col_data);
						$this->t->parse('columns','column',True);
					}

					# Owner name
					if($this->prefs['owner'])
					{
						$this->t->set_var('col_data',$GLOBALS['phpgw']->accounts->id2name($files['owner_id']));
						$this->t->parse('columns','column',True);
					}

					# Creator name
					if($this->prefs['createdby_id'])
					{
						$this->html_table_col_begin();
						if($files['createdby_id'])
						{
							$col_data=$GLOBALS['phpgw']->accounts->id2name($files['createdby_id']);
						}
						else $col_data='';

						$this->t->set_var('col_data',$col_data);
						$this->t->parse('columns','column',True);
					}

					# Modified by name
					if($this->prefs['modifiedby_id'])
					{
						if($files['modifiedby_id'])
						{
							$col_data=$GLOBALS['phpgw']->accounts->id2name($files['modifiedby_id']);
						}
						else $col_data='';
						$this->t->set_var('col_data',$col_data);
						$this->t->parse('columns','column',True);
					}

					# Application
					if($this->prefs['app'])
					{
						$col_data=$files['app'];
						$this->t->set_var('col_data',$col_data);
						$this->t->parse('columns','column',True);
					}

					# Comment
					if($this->prefs['comment'])
					{
						if (strlen($files['comment']) == 0 )
							$files['comment'] = "&lt;".lang("no comments")."&gt;";
						$col_data='<span id="'.$files['name'].'" onClick="setComments(this)">'.$files['comment'].'</span>';
						$this->t->set_var('col_data',$col_data);
						$this->t->parse('columns','column',True);
					}

					# Version
					if($this->prefs['version'])
					{
						$link=$this->encode_href('/index.php','menuaction=filemanager.uifilemanager.history','file='.$files['name'].'&path='.$this->path);
						$col_data='<a href="'.$link.'" target="_blank">'.$files['version'].'</a>';
						$this->t->set_var('col_data',$col_data);
						$this->t->parse('columns','column',True);
					}

					$usedspace += $files['size'];

					$this->t->set_var('row_tr_color','');
					$this->t->parse('rows','row');
					$this->t->pparse('out','row');
				}
			}

			// The file and directory information
			$vars[lang_files_in_this_dir]=lang('Files in this directory');
			$vars[files_in_this_dir]=$this->numoffiles;

			$vars[lang_used_space]=lang('Used space');
			$vars[used_space]=$this->bo->borkb($usedspace, NULL, 1);

			if($this->path == $this->bo->homedir || $this->path == $this->bo->fakebase)
			{
				$vars[lang_unused_space]=lang('Unused space');
				$vars[unused_space]=$this->bo->borkb($this->bo->userinfo['hdspace'] - $usedspace, NULL, 1);

				$tmp_arr=array(
					'string'	=> $this->path,
					'relatives'	=> array(RELATIVE_NONE)
				);

				$ls_array = $this->bo->vfs->ls($tmp_arr);

				$vars[lang_total_files]=lang('Total Files');
				$vars[total_files]=	count($ls_array);
			}

			$this->t->set_var($vars);
			$this->t->pparse('out','filemanager_footer');

			$GLOBALS['phpgw']->common->phpgw_footer();
			$GLOBALS['phpgw']->common->phpgw_exit();
		}

		function readFilesInfo()
		{
			// start files info

			# Read in file info from database to use in the rest of the script
			# $fakebase is a special directory.  In that directory, we list the user's
			# home directory and the directories for the groups they're in
			$this->numoffiles = 0;
			if($this->path == $this->bo->fakebase)
			{
				// FIXME this test can be removed
				if(!$this->bo->vfs->file_exists(array('string' => $this->bo->homedir, 'relatives' => array(RELATIVE_NONE))))
				{
					$this->bo->vfs->mkdir(array('string' => $this->bo->homedir, 'relatives' => array(RELATIVE_NONE)));
				}

				$ls_array = $this->bo->vfs->ls(array(
					'string' => $this->bo->homedir,
					'relatives' => array(RELATIVE_NONE),
					'checksubdirs' => False,
					'nofiles' => True
				));

				$this->files_array[] = $ls_array[0];
				$this->numoffiles++;

				reset($this->readable_groups);
				while(list($num, $group_array) = each($this->readable_groups))
				{
					# If the group doesn't have access to this app, we don't show it
					/*if(!$this->groups_applications[$group_array['account_name']][$this->bo->appname]['enabled'])
					{
						continue;
					}
					*/


					if(!$this->bo->vfs->file_exists(array('string' => $this->bo->fakebase.'/'.$group_array['account_name'],'relatives'	=> array(RELATIVE_NONE))))
					{
						$this->bo->vfs->override_acl = 1;
						$this->bo->vfs->mkdir(array(
							'string' => $this->bo->fakebase.'/'.$group_array['account_name'],
							'relatives' => array(RELATIVE_NONE)
						));

						// FIXME we just created a fresh group dir so we know there nothing in it so we have to remove all existing content
						
						
						$this->bo->vfs->override_acl = 0;

						$this->bo->vfs->set_attributes(array('string' => $this->bo->fakebase.'/'.$group_array['account_name'],'relatives'	=> array(RELATIVE_NONE),'attributes' => array('owner_id' => $group_array['account_id'],'createdby_id' => $group_array['account_id'])));
					}

					$ls_array = $this->bo->vfs->ls(array('string' => $this->bo->fakebase.'/'.$group_array['account_name'],'relatives'	=> array(RELATIVE_NONE),'checksubdirs' => False,'nofiles' => True));

					$this->files_array[] = $ls_array[0];

					$this->numoffiles++;
				}
			}
			else
			{
				$ls_array = $this->bo->vfs->ls(array(
					'string' => $this->path,
					'relatives'	=> array(RELATIVE_NONE),
					'checksubdirs' => False,
					'nofiles'	=> False,
					'orderby'	=> $this->sortby
				));

				while(list($num, $file_array) = each($ls_array))
				{
					$this->numoffiles++;
					$this->files_array[] = $file_array;
				}
			}

			if(!is_array($this->files_array))
			{
				$this->files_array = array();
			}
			// end file count
		}

		function toolbar($type)
		{
			switch($type)
			{
				case 'location':
					$toolbar='
					<div id="fmLocation">
					<table cellspacing="10" cellpadding="0" border="0">
					<tr>
					';
//					$toolbar.='<td><img alt="spacer" src="'.$GLOBALS['phpgw']->common->image('phpgwapi','buttonseparator').'" height="27" width="8"></td>';
//					$toolbar.='<td><img alt="spacer" src="'.$GLOBALS['phpgw']->common->image('filemanager','spacer').'" height="27" width="1"></td>';

					// go up icon when we're not at the top, dont allow to go outside /home = fakebase
					if($this->path != '/' && $this->path != $this->bo->fakebase)
					{
						$link=$this->encode_href('/index.php','menuaction=filemanager.uifilemanager.index','path='.$this->lesspath);
						$toolbar.=$this->linkButton($link,'up',lang('go up'));
					}

					// go home icon when we're not home already
					if($this->path != $this->bo->homedir)
					{
						$link=$this->encode_href('/index.php','menuaction=filemanager.uifilemanager.index','path='.$this->bo->homedir);
						$toolbar.=$this->linkButton($link,'home',lang('go home'));
					}

					// reload button with this url
					$link=$this->encode_href('/index.php','menuaction=filemanager.uifilemanager.index','path='.$this->path);
					$toolbar.=$this->linkButton($link,'reload',lang('reload'));

					$toolbar.='<td>'.lang('Location').':&nbsp;';
					//$toolbar.='<input id="fmInputLocation" type="text" size="20" disabled="disabled" name="location" value="'.$this->disppath.'"/>&nbsp;';
					$current_option='<option>'.$this->disppath.'</option>';
					// selectbox for change/move/and copy to
					$dirs_options=$this->all_other_directories_options();
					$toolbar.='<select id="cdtodir" name="cdtodir" onChange="document.formfm.changedir.value=\'true\';document.formfm.submit()">'.$current_option.$dirs_options.'</select>
					<input type="hidden" name="changedir" value="false"></td>
					';
					//$toolbar.=$this->inputImage('goto','goto',lang('Quick jump to'));
					// upload button
					/*if($this->path != '/' && $this->path != $this->bo->fakebase && $this->can_add)
					{
						// upload button
						$toolbar.=$this->inputImage('upload','upload',lang('Upload'));
						

					}*/
					$toolbar.='</tr></table>';
					$toolbar.='</div><br><br>';
					break;
				case 'list_nav':
					$toolbar='
					<table cellspacing="10" cellpadding="0" border="0">
					<tr>';
					// selectbox for change/move/and copy to
					// submit buttons for
					if($this->path != '/' && $this->path != $this->bo->fakebase)
					{
						// create dir and file button
						if($this->can_add)
						{
							$toolbar.='<td><input type="hidden" id="newfile_or_dir" name="newfile_or_dir" value="" /></td>';
							//TODO : create folder with problems
							//$toolbar3.=$this->inputImage('newdir','createdir',lang('Create Folder'));
							$toolbar.=$this->inputImage('new','createfile',lang('New...'));
						}

						if($this->can_edit)
						{
							// edit text file button
							$toolbar.=$this->inputImage('edit','edit',lang('edit'));
						}

						if($this->can_edit)
						{
							$toolbar.=$this->inputImage('rename','rename',lang('Rename'));
						}

						if($this->can_delete)
						{
							$toolbar.=$this->inputImage('delete','delete',lang('Delete'));
						}

					}

						// copy and move buttons
						if($this->path != '/' && $this->path != $this->bo->fakebase)
						{
							$dirs_options=$this->all_other_directories_options();
							if (strlen($dirs_options) > 0){
								$toolbar3.=$this->inputImage('copy_to','copy_to',lang('Copy to'));
								if ($this->can_delete)
									$toolbar3.=$this->inputImage('move_to','move_to',lang('Move to'));
							}
							$toolbar3.='<td><select name="todir" style="visibility:hidden">'.$dirs_options.'</select></td>';

						}

						if($toolbar3)
						{
							$toolbar.=$toolbar3;
						/*	$toolbar.='
							<table cellspacing="1" cellpadding="0" border="0">
							<tr>'.$toolbar3;*/
						}
					$toolbar.='</tr></table>';

					break;
				default:$x='';
			}

			if($toolbar)
			{
				return $toolbar;
			}
		}


		# Handle Moving Files and Directories
		function moveTo()
		{
			if(!$this->todir)
			{
				$this->messages[] = lang('Error:').lang('Could not move file because no destination directory is given ', $this->disppath.'/'.$file);

			}
			else
			{

				while(list($num, $file) = each($this->fileman))
				{
					if($this->bo->vfs->mv(array(
						'from'	=> $file,
						'to'	=> $this->todir . '/' . $file,
						'relatives'	=> array(RELATIVE_ALL, RELATIVE_NONE)
					)))
					{
						$moved++;
						$this->messages[]=lang('Moved %1 to %2', $this->disppath.'/'.$file, $this->todir.'/'.$file);
					}
					else
					{
						$this->messages[] = lang('Error:').lang('Could not move %1 to %2', $this->disppath.'/'.$file, $this->todir.'/'.$file);
					}
				}
			}

			if($moved)
			{
				$x=0;
			}

			$this->readFilesInfo();
			$this->filelisting();
		}

		// Handle Copying of Files and Directories
		function copyTo()
		{
			if(!$this->todir)
			{
				$this->messages[] = lang('Error:').lang('Could not copy file because no destination directory is given ', $this->disppath.'/'.$file);

			}
			else
			{
				while(list($num, $file) = each($this->fileman))
				{
					if($this->bo->vfs->cp(array(
						'from'	=> $file,
						'to'	=> $this->todir . '/' . $file,
						'relatives'	=> array(RELATIVE_ALL, RELATIVE_NONE)
					)))
					{
						$copied++;
						$this->messages[] = lang('Copied %1 to %2', $this->disppath.'/'.$file, $this->todir.'/'.$file);
					}
					else
					{
						$this->messages[] = lang('Error:').lang('Could not copy %1 to %2', $this->disppath.'/'.$file, $this->todir.'/'.$file);
					}
				}
			}
			if($copied)
			
			{
				$x=0;
			}

			$this->readFilesInfo();
			$this->filelisting();
		}

		function createdir()
		{
			if($this->newdir_x && $this->newfile_or_dir)
			{
				if($this->bo->badchar = $this->bo->bad_chars($this->newfile_or_dir, True, True))
				{
					$this->messages[]= lang('Error:').$this->bo->html_encode(lang('Directory names cannot contain "%1"', $badchar), 1);
				}

				/* TODO is this right or should it be a single $ ? */
				if($$this->newfile_or_dir[strlen($this->newfile_or_dir)-1] == ' ' || $this->newfile_or_dir[0] == ' ')
				{
					$this->messages[]= lang('Error:').lang('Cannot create directory because it begins or ends in a space');
				}

				$ls_array = $this->bo->vfs->ls(array(
					'string'	=> $this->path . '/' . $this->newfile_or_dir,
					'relatives'	=> array(RELATIVE_NONE),
					'checksubdirs'	=> False,
					'nofiles'	=> True
				));

				$fileinfo = $ls_array[0];

				if($fileinfo['name'])
				{
					if($fileinfo['mime_type'] != 'Directory')
					{
						$this->messages[]= lang('Error:').lang('%1 already exists as a file',$fileinfo['name']);
					}
					else
					{
						$this->messages[]= lang('Error:').lang('Directory %1 already exists', $fileinfo['name']);
					}
				}
				else
				{
					if($this->bo->vfs->mkdir(array('string' => $this->newfile_or_dir)))
					{
						$this->messages[]=lang('Created directory %1', $this->disppath.'/'.$this->newfile_or_dir);
					}
					else
					{
						$this->messages[]=lang('Error:').lang('Could not create %1', $this->disppath.'/'.$this->newfile_or_dir);
					}
				}

				$this->readFilesInfo();
				$this->filelisting();
			}
		}
		function getReturnExecuteForm(){
			$response = $_SESSION['response'];
			$_SESSION['response'] = null;
			echo $response;
			return;
		}
		function showUploadboxes()
		{
			$this->t->set_file(array('upload' => 'upload.tpl'));
			$this->t->set_block('upload','upload_header','upload_header');
			$this->t->set_block('upload','row','row');
			$this->t->set_block('upload','upload_footer','upload_footer');

			if($this->path != '/' && $this->path != $this->bo->fakebase && $this->can_add)
			{
				$vars[max_size]=lang('Note: Uploaded is limited to %1MB',($this->current_config['filemanager_Max_file_size']));
				$vars[form_action]=$GLOBALS[phpgw]->link('/filemanager/inc/upload.php');
				//$vars[form_action]=$GLOBALS[phpgw]->link('/index.php','menuaction=filemanager.uifilemanager.index');
				$vars[path]=$this->path;
				$vars[lang_file]=lang('File');
				$vars[lang_comment]=lang('Comment');
				$vars[num_upload_boxes]=1;
				$this->t->set_var($vars);
				$this->t->pparse('out','upload_header');

				$this->t->set_var('row_tr_color',$tr_color);
				$this->t->parse('rows','row');
				$this->t->pparse('out','row');

				$vars[lang_upload]=lang('Upload files');
				$vars[change_upload_boxes].=lang('Show') . '&nbsp;';
				$this->t->set_var($vars);
				$this->t->pparse('out','upload_footer');
			}
		}

		/* create textfile */
		function createfile()
		{
			$this->filename=$this->newfile_or_dir;
			if($this->filename)
			{
				if($badchar = $this->bo->bad_chars($this->filename, True, True))
				{
					$this->messages[] = lang('Error:').lang('File names cannot contain "%1"',$badchar);

					$this->fileListing();
				}

				if($this->bo->vfs->file_exists(array(
					'string'=> $this->filename,
					'relatives'	=> array(RELATIVE_ALL)
				)))
				{
					$this->messages[]= lang('Error:').lang('File %1 already exists. Please edit it or delete it first.', $this->filename);
					$this->fileListing();
				}

				if($this->bo->vfs->touch(array(
					'string'	=> $this->filename,
					'relatives'	=> array(RELATIVE_ALL)
				)))
				{
					$this->edit = 1;
					$this->numoffiles++;
					$this->edit();
				}
				else
				{
					$this->messages[]= lang('Error:').lang('File %1 could not be created.', $this->filename);
					$this->fileListing();
				}
			}
		}

		# Handle Editing files
		function edit()
		{
			if($this->filename)
			{
				if (! $this->vfs_functions->verifyLock($this->path.'/'.$this->filename,RELATIVE_NONE)){
					echo $this->messages['0'];
					$GLOBALS['phpgw']->redirect('/index.php');

					//$GLOBALS['phpgw']->common->phpgw_exit();
				}
				$ls_array = $this->bo->vfs->ls(array(
					'string'        => $this->path.'/'.$this->filename,
					'relatives'     => array(RELATIVE_NONE),
					'checksubdirs'  => False,
					'nofiles'       => True
				));
				$this->bo->vfs->touch(array(
					'string'=> $this->path.'/'.$this->filename,
					'relatives'     => array(RELATIVE_NONE)
				));


				if($ls_array[0]['mime_type'])
				{
					$mime_type = $ls_array[0]['mime_type'];
				}
				elseif($this->prefs['viewtextplain'])
				{
					$mime_type = 'text/plain';
				}
				$editable = array('','text/plain','text/csv','text/html','text/text','message/rfc822');

				if(!in_array($mime_type,$editable)){
					echo lang('Impossbile to edit this file');
					return False;
				}
			}

			$this->readFilesInfo();

			if ($mime_type == 'text/html')
				$this->t->set_file(array('filemanager_edit' => 'edit_html.tpl'));
			else
				$this->t->set_file(array('filemanager_edit' => 'edit_file.tpl'));

			$this->t->set_block('filemanager_edit','row','row');


			$vars[refresh_script] = "<script src='filemanager/js/refresh.js'></script>";

			$vars[preview_content]='';
			if($this->edit_file)
			{
				$this->edit_file_content = stripslashes($this->edit_file_content);
			}

			if($this->edit_preview_x)
			{
				$content = $this->edit_file_content;

				$vars[lang_preview_of]=lang('Preview of %1', $this->path.'/'.$edit_file);

				$vars[preview_content]=nl2br($content);
			}
			elseif($this->edit_save_x || $this->edit_save_done_x)
			{
				$content = $this->edit_file_content;
				//die( $content);
				if($this->bo->vfs->write(array(
					'string'	=> $this->path.'/'.$this->edit_file,
					'relatives'	=> array(RELATIVE_NONE),
					'content'	=> $content
				)))
				{
					$this->messages[]=lang('Saved %1', $this->path.'/'.$this->edit_file);

					if($this->edit_save_done_x)
					{
						$this->readFilesInfo();
						$this->fileListing();
						exit;
					}
				}
				else
				{
					echo lang('Could not save %1', $this->path.'/'.$this->edit_file);
					$this->messages[]=lang('Could not save %1', $this->path.'/'.$this->edit_file);
				}
			}

			# If we're in preview or save mode, we only show the file
			# being previewed or saved
			if($this->edit_file &&($this->filename != $this->edit_file))
			{
				continue;
			}

			if($this->filename && $this->bo->vfs->file_exists(array(
				'string'	=> $this->filename,
				'relatives'	=> array(RELATIVE_ALL)
			)))
			{
				if($this->edit_file)
				{
					$content = stripslashes($this->edit_file_content);
				}
				else
				{
					$content = $this->bo->vfs->read(array('string' => $this->filename));
				}
				$vars[form_action]= $GLOBALS['phpgw']->link('/index.php','menuaction=filemanager.uifilemanager.index','path='.$this->path);
				$vars[edit_file]=$this->filename;
				# We need to include all of the fileman entries for each file's form,
				# so we loop through again
				for($i = 0; $i != $this->numoffiles; $i++)
				{
					if($this->filename) $value='value="'.$this->filename.'"';
					$vars[filemans_hidden]='<input type="hidden" name="filename" '.$value.' />';
				}
				$vars[file_content]=$content;

				$vars[buttonPreview]=$this->inputButton('edit_preview','edit_preview',lang('Preview %1', $this->bo->html_encode($this->fileman[$j], 1)));
				$vars[buttonSave]=$this->inputButton('edit_save','save',lang('Save %1', $this->bo->html_encode($this->filename, 1)));
				$vars[buttonDone]=$this->inputButton('edit_save_done','ok',lang('Save %1, and go back to file listing ', $this->bo->html_encode($this->filename, 1)));
				$vars[buttonCancel]=$this->inputButton('edit_cancel','cancel',lang('Cancel editing %1 without saving', $this->bo->html_encode($this->filename, 1)));

				if ($mime_type == 'text/html'){
					$vars[fck_edit] = '<script type="text/javascript" src="filemanager/tp/ckeditor/ckeditor.js"></script>
						<textarea cols="80" id="edit_file_content" name="edit_file_content" rows="10">'.$content.'</textarea>
						<script type="text/javascript"> CKEDITOR.replace( \'edit_file_content\',{
removePlugins : \'elementspath\',
skin : \'office2003\',
toolbar : [["Source","Preview","-","Cut","Copy","Paste","-","Print",
"Undo","Redo","-","Find","Replace","-","SelectAll" ],
["Table","HorizontalRule","Smiley","SpecialChar","PageBreak","-","Bold",
"Italic","Underline","Strike","-","Subscript","Superscript",
"NumberedList","BulletedList","-","Outdent","Indent","Blockquote",
"JustifyLeft","JustifyCenter","JustifyRight","JustifyBlock",
"Link", "TextColor","BGColor","Maximize"],
["Styles","Format","Font","FontSize"]]
				});</script>';

				}


				$this->t->set_var($vars);
				$this->t->parse('rows','row');
				$this->t->pparse('out','row');

			}

		}

		function history()
		{
			if($this->file) // FIXME this-file is never defined
			{
				$journal_array = $this->bo->vfs->get_journal(array(
					'string'	=> $this->file,//FIXME
					'relatives'	=> array(RELATIVE_ALL)
				));

				if(is_array($journal_array))
				{
					$this->html_table_begin();
					$this->html_table_row_begin();
					$this->html_table_col_begin();
					echo lang('Date');
					$this->html_table_col_end();
					$this->html_table_col_begin();
					echo lang('Version');
					$this->html_table_col_end();
					$this->html_table_col_begin();
					echo lang('Who');
					$this->html_table_col_end();
					$this->html_table_col_begin();
					echo lang('Operation');
					$this->html_table_col_end();
					$this->html_table_row_end();

					while(list($num, $journal_entry) = each($journal_array))
					{
						$this->html_table_row_begin();
						$this->html_table_col_begin();
						$this->bo->html_text($journal_entry['created'] . '&nbsp;&nbsp;&nbsp;');
						$this->html_table_col_end();
						$this->html_table_col_begin();
						$this->bo->html_text($journal_entry['version'] . '&nbsp;&nbsp;&nbsp;' );
						$this->html_table_col_end();
						$this->html_table_col_begin();
						$this->bo->html_text($GLOBALS['phpgw']->accounts->id2name($journal_entry['owner_id']) . '&nbsp;&nbsp;&nbsp;');
						$this->html_table_col_end();
						$this->html_table_col_begin();
						$this->bo->html_text($journal_entry['comment']);
						$this->html_table_col_end();
					}

					$this->html_table_end();
					$GLOBALS['phpgw']->common->phpgw_footer();
					$GLOBALS['phpgw']->common->phpgw_exit();
				}
				else
				{
					echo lang('No version history for this file/directory');
				}
			}
		}
		function view()
		{
			if (!$this->bo->vfs->acl_check(array(
				'string'        => $this->path,
				'relatives'     => array(RELATIVE_NONE),
				'operation'     => PHPGW_ACL_READ
			)))
			{
				echo lang("You have no permission to access this file");
				return false;
			}
			if($this->file) //FIXME
			{
				$ls_array = $this->bo->vfs->ls(array(
					'string'	=> $this->path.'/'.$this->file,//FIXME
					'relatives'	=> array(RELATIVE_NONE),
					'checksubdirs'	=> False,
					'nofiles'	=> True
				));
				if ($ls_array[0]['size'] > 4194304){
					header('Location:'.$this->encode_href('inc/download.php','file='.base64_encode($this->file).'&path='.base64_encode($this->path)));
					return;
				}
				$_SESSION['debug'][] = $ls_array;
				if($ls_array[0]['mime_type'])
				{
					$mime_type = $ls_array[0]['mime_type'];
				}
				elseif($this->prefs['viewtextplain'])
				{
					$mime_type = 'text/plain';
				}
				$viewable = array('','text/plain','text/csv','text/html','text/text');

				if(in_array($mime_type,$viewable))
				{
					/*Note: if you put application/octet-stream you force download */
					header('Content-type: ' . $mime_type);
					header('Content-disposition: filename="' . $this->file . '"');//FIXME
					Header("Pragma: public");
				}
				else
				{
					$GLOBALS['phpgw']->browser->content_header($this->file,$mime_type);//FIXME
				}
 

				echo $this->bo->vfs->read(array(
					'string'	=> $this->path.'/'.$this->file,//FIXME
					'relatives'	=> array(RELATIVE_NONE)
				));
				$GLOBALS['phpgw']->common->phpgw_exit();
			}
		}

		function export(){
			if($this->file)
			{
				$ls_array = $this->bo->vfs->ls(array(
					'string'        => $this->path.'/'.$this->file,
					'relatives'     => array(RELATIVE_NONE),
					'checksubdirs'  => False,
					'nofiles'       => True
				));
				/*$timestamp = $this->vfs_functions->dateString2timeStamp($ls_array[0]['modified']);
				if (time() - $timestamp < 60 && $ls_array[0]['modifiedby_id'] != $GLOBALS['phpgw_info']['user']['account_id']);
				{
					// recently than last minute: someone is editing
				}*/
				$mime_type = $ls_array[0]['mime_type'];
				$formats = array('text/html');
				if(!in_array($mime_type,$formats)){
					echo lang('Impossbile to export this file');
					return False;
				}
				$content = $this->bo->vfs->read(array('string' => $this->path.'/'.$this->file,
					       'relatives'     => array(RELATIVE_NONE)
				       ));

				include_once('filemanager/tp/dompdf/dompdf_config.inc.php');
				$dompdf = new DOMPDF();
				$dompdf->load_html($content);
				$dompdf->set_paper($this->prefs['pdf_paper_type'], $this->prefs['pdf_type']);
				/* Would be nice to implement 'Title','Subject','Author','Creator','CreationDate'*/
				$dompdf->render();
				$dompdf->stream(strtok($this->file,'.').".pdf");
				$GLOBALS['phpgw']->common->phpgw_exit();
			}
		}

		//give back an array with all directories except current and dirs that are not accessable
		function all_other_directories_options()
		{
			# First we get the directories in their home directory
			$dirs = array();
			$dirs[] = array('directory' => $this->bo->fakebase, 'name' => $this->bo->userinfo['account_lid']);

			$tmp_arr=array(
				'string'	=> $this->bo->homedir,
				'relatives'	=> array(RELATIVE_NONE),
				'checksubdirs'	=> True,
				'mime_type'	=> 'Directory'
			);

			$ls_array = $this->bo->vfs->ls($tmp_arr);

			while(list($num, $dir) = each($ls_array))
			{
				$dirs[] = $dir;
			}


			# Then we get the directories in their readable groups' home directories
			reset($this->readable_groups);
			while(list($num, $group_array) = each($this->readable_groups))
			{
				/* Don't list directories for groups that don't have access
				if(!$this->groups_applications[$group_array['account_name']][$this->bo->appname]['enabled'])
				{
]					continue;
				}*/

				$dirs[] = array('directory' => $this->bo->fakebase, 'name' => $group_array['account_name']);

				$tmp_arr=array(
					'string'	=> $this->bo->fakebase.'/'.$group_array['account_name'],
					'relatives'	=> array(RELATIVE_NONE),
					'checksubdirs'	=> True,
					'mime_type'	=> 'Directory'
				);

				$ls_array = $this->bo->vfs->ls($tmp_arr);
				while(list($num, $dir) = each($ls_array))
				{
					$dirs[] = $dir;
				}
			}

			reset($dirs);
			while(list($num, $dir) = each($dirs))
			{
				if(!$dir['directory'])
				{
					continue;
				}

				# So we don't display //
				if($dir['directory'] != '/')
				{
					$dir['directory'] .= '/';
				}

				# No point in displaying the current directory, or a directory that doesn't exist
				if((($dir['directory'] . $dir['name']) != $this->path) && $this->bo->vfs->file_exists(array('string' => $dir['directory'] . $dir['name'],'relatives' => array(RELATIVE_NONE))))
				{
					//FIXME replace the html_form_option function
					$options .= $this->html_form_option($dir['directory'] . $dir['name'], $dir['directory'] . $dir['name']);
				}
			}

			return $options;
		}

		/* seek icon for mimetype else return an unknown icon */
		function mime_icon($mime_type, $size=16)
		{
			if(!$mime_type) $mime_type='unknown';

			$mime_type=str_replace	('/','_',$mime_type);

			$img=$GLOBALS['phpgw']->common->image('filemanager','mime'.$size.'_'.strtolower($mime_type));
			if(!$img) $img=$GLOBALS['phpgw']->common->image('filemanager','mime'.$size.'_unknown');

			$icon='<img src="'.$img.' "alt="'.lang($mime_type).'" />';
			return $icon;
		}

		function linkButton($link,$img='',$description='')
		{
			$image=$GLOBALS['phpgw']->common->image('filemanager','button_'.strtolower($img));

			if($img)
			{
				return '<td class="" align="center" valign="middle" height="28" width="70">
				<a href="'.$link.'" title="'.$description.'"><img src="'.$image.'" alt="'.$description.'"/></a><br><small>'.$description.'</small>
				</td>';
			}
		}

		function inputButton($name,$img='',$description='')
		{
			$image=$GLOBALS['phpgw']->common->image('filemanager','button_'.strtolower($img));

			if($img)
			{
				return '<td class="" align="center" valign="middle" height="28" width="70">
				<input title="'.$description.'" name="'.$name.'" type="image" alt="'.$name.'" src="'.$image.'" value="clicked" /><br><small>'.$description.'</small>
				</td>';
			}
		}
		function inputImage($name,$img='',$description='')
		{
			$image=$GLOBALS['phpgw']->common->image('filemanager','button_'.strtolower($img));

			if($img)
			{
				return '<td class="" align="center" valign="middle" height="28" width="70">
				<img onClick="toolbar_control(\''.$name.'\')" title="'.$description.'" name="'.$name.'" alt="'.$name.'" src="'.$image.'" /><br><small>'.$description.'</small>
				</td>';
			}
		}



		function html_form_input($type = NULL, $name = NULL, $value = NULL, $maxlength = NULL, $size = NULL, $checked = NULL, $string = '', $return = 1)
		{
			$text = ' ';
			if($type != NULL && $type)
			{
				if($type == 'checkbox')
				{
					$value = $this->bo->string_encode($value, 1);
				}
				$text .= 'type="'.$type.'" ';
			}
			if($name != NULL && $name)
			{
				$text .= 'name="'.$name.'" ';
			}
			if($value != NULL && $value)
			{
				$text .= 'value="'.$value.'" ';
			}
			if(is_int($maxlength) && $maxlength >= 0)
			{
				$text .= 'maxlength="'.$maxlength.'" ';
			}
			if(is_int($size) && $size >= 0)
			{
				$text .= 'size="'.$size.'" ';
			}
			if($checked != NULL && $checked)
			{
				$text .= 'checked ';
			}

			return '<input'.$text.$string.'>';
		}

		function html_form_option($value = NULL, $displayed = NULL, $selected = NULL, $return = 0)
		{
			$text = ' ';
			if($value != NULL && $value)
			{
				$text .= ' value="'.$value.'" ';
			}
			if($selected != NULL && $selected)
			{
				$text .= ' selected';
			}
			return  '<option'.$text.'>'.$displayed.'</option>';
		}

		function encode_href($href = NULL, $args = NULL , $extra_args)
		{
			$href = $this->bo->string_encode($href, 1);
			$all_args = $args.'&'.$this->bo->string_encode($extra_args, 1);

			$address = $GLOBALS['phpgw']->link($href, $all_args);

			return $address;
		}

		function html_link($href = NULL, $args = NULL , $extra_args, $text = NULL, $return = 1, $encode = 1, $linkonly = 0, $target = NULL)
		{
			//	unset($encode);
			if($encode)
			{
				$href = $this->bo->string_encode($href, 1);
				$all_args = $args.'&'.$this->bo->string_encode($extra_args, 1);
			}
			else
			{
				//				$href = $this->bo->string_encode($href, 1);
				$all_args = $args.'&'.$extra_args;
			}
			###
			# This decodes / back to normal
			###
			//			$all_args = preg_replace("/%2F/", "/", $all_args);
			//			$href = preg_replace("/%2F/", "/", $href);

			/* Auto-detect and don't disturb absolute links */
			if(!preg_match("|^http(.{0,1})://|", $href))
			{
				//Only add an extra / if there isn't already one there

				// die(SEP);
				if(!($href[0] == SEP))
				{
					$href = SEP . $href;
				}

				/* $phpgw->link requires that the extra vars be passed separately */
				//				$link_parts = explode("?", $href);
				$address = $GLOBALS['phpgw']->link($href, $all_args);
				//				$address = $GLOBALS['phpgw']->link($href);
			}
			else
			{
				$address = $href;
			}

			/* If $linkonly is set, don't add any HTML */
			if($linkonly)
			{
				$rstring = $address;
			}
			else
			{
				if($target)
				{
					$target = 'target='.$target;
				}

				$text = trim($text);
				$rstring = '<a href="'.$address.'" '.$target.'>'.$text.'</a>';
			}

			return($this->bo->eor($rstring, $return));
		}

		function html_table_begin($width = NULL, $border = NULL, $cellspacing = NULL, $cellpadding = NULL, $rules = NULL, $string = '', $return = 0)
		{
			if($width != NULL && $width)
			{
				$width = "width=$width";
			}
			if(is_int($border) && $border >= 0)
			{
				$border = "border=$border";
			}
			if(is_int($cellspacing) && $cellspacing >= 0)
			{
				$cellspacing = "cellspacing=$cellspacing";
			}
			if(is_int($cellpadding) && $cellpadding >= 0)
			{
				$cellpadding = "cellpadding=$cellpadding";
			}
			if($rules != NULL && $rules)
			{
				$rules = "rules=$rules";
			}

			$rstring = "<table $width $border $cellspacing $cellpadding $rules $string>";
			return($this->bo->eor($rstring, $return));
		}

		function html_table_end($return = 0)
		{
			$rstring = "</table>";
			return($this->bo->eor($rstring, $return));
		}

		function html_table_row_begin($align = NULL, $halign = NULL, $valign = NULL, $bgcolor = NULL, $string = '', $return = 0)
		{
			if($align != NULL && $align)
			{
				$align = "align=$align";
			}
			if($halign != NULL && $halign)
			{
				$halign = "halign=$halign";
			}
			if($valign != NULL && $valign)
			{
				$valign = "valign=$valign";
			}
			if($bgcolor != NULL && $bgcolor)
			{
				$bgcolor = "bgcolor=$bgcolor";
			}
			$rstring = "<tr $align $halign $valign $bgcolor $string>";
			return($this->bo->eor($rstring, $return));
		}

		function html_table_row_end($return = 0)
		{
			$rstring = "</tr>";
			return($this->bo->eor($rstring, $return));
		}

		function html_table_col_begin($align = NULL, $halign = NULL, $valign = NULL, $rowspan = NULL, $colspan = NULL, $string = '', $return = 0)
		{
			if($align != NULL && $align)
			{
				$align = "align=$align";
			}
			if($halign != NULL && $halign)
			{
				$halign = "halign=$halign";
			}
			if($valign != NULL && $valign)
			{
				$valign = "valign=$valign";
			}
			if(is_int($rowspan) && $rowspan >= 0)
			{
				$rowspan = "rowspan=$rowspan";
			}
			if(is_int($colspan) && $colspan >= 0)
			{
				$colspan = "colspan=$colspan";
			}

			$rstring = "<td $align $halign $valign $rowspan $colspan $string>";
			return($this->bo->eor($rstring, $return));
		}

		function html_table_col_end($return = 0)
		{
			$rstring = "</td>";
			return($this->bo->eor($rstring, $return));
		}
	}
